package com.jeeplus.modules.sg.managementcenter.activiti.utils;

import com.google.common.collect.Maps;
import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.modules.sg.managementcenter.activiti.entity.Construction;
import com.jeeplus.modules.sg.managementcenter.activiti.entity.Disclose;
import com.jeeplus.modules.sg.managementcenter.activiti.entity.MyNeedList;
import org.apache.poi.ss.usermodel.Row;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MyImportUtils {
    public static Map<String, Object> errorTips(List<Construction> constructionList) {
        String tips = "";
        String fin = "";
        List<Construction> newConList = new ArrayList<>();
        boolean flag = false;
        for (Construction c : constructionList) {
            Disclose disclose = c.getDisclose();
            String hasImplemented = disclose.getHasImplemented();
            String sceneDescription = disclose.getSceneDescription();
            String isImplement = disclose.getIsImplement();
            String noImplementation = disclose.getNoImplementation();
            String whetherComplete = disclose.getWhetherComplete();
            String drawingDescription = disclose.getDrawingDescription();
            String whetherStandard = disclose.getWhetherStandard();
            String normativeDrawings = disclose.getNormativeDrawings();
            String whetherDrawing = disclose.getWhetherDrawing();
            String problemDescription = disclose.getProblemDescription();
            String whetherChannel = disclose.getWhetherChannel();
            String constructionDescription = disclose.getConstructionDescription();
            String civilAdjusted = disclose.getCivilAdjusted();
            String descriptionPlans = disclose.getDescriptionPlans();
            String descriptionAdjustment = disclose.getDescriptionAdjustment();
            String electricalAdjusted = disclose.getElectricalAdjusted();
            String adjustmentDescription = disclose.getAdjustmentDescription();
            String doesChange = disclose.getDoesChange();
            String automatedContent = disclose.getAutomatedContent();
            String automatedAdjustment = disclose.getAutomatedAdjustment();
            String otherAdjusted = disclose.getOtherAdjusted();
            String descriptionReasons = disclose.getDescriptionReasons();
            if ("是".equals(hasImplemented)) {
                if (empty(sceneDescription)) {
                    flag = true;
                    tips += "现场情况描述有误\t";
                }
            }
            if ("否".equals(isImplement)) {
                if (empty(noImplementation)) {
                    flag = true;
                    tips += "实施无必要描述有误\t";
                }
            }
            if ("否".equals(whetherComplete)) {
                if (empty(drawingDescription)) {
                    flag = true;
                    tips += "图纸完整性描述有误\t";
                }
            }
            if ("否".equals(whetherStandard)) {
                if (empty(normativeDrawings)) {
                    flag = true;
                    tips += "图纸规范性描述有误\t";
                }
            }
            if ("是".equals(whetherDrawing)) {
                if (empty(problemDescription)) {
                    flag = true;
                    tips += "典设图问题描述有误\t";
                }
            }
            if ("是".equals(whetherChannel)) {
                if (empty(constructionDescription)) {
                    flag = true;
                    tips += "施工通道情况描述有误\t";
                }
            }
            if ("是".equals(civilAdjusted)) {
                if (empty(descriptionPlans) || empty(descriptionAdjustment)) {
                    flag = true;
                    tips += "土建方案变更内容描述或土建工作量调整内容描述有误\t";
                }
            }
            if ("是".equals(electricalAdjusted)) {
                if (empty(adjustmentDescription)) {
                    flag = true;
                    tips += "调整原因描述有误\t";
                }
            }
            if ("是".equals(doesChange)) {
                if (empty(automatedContent) || empty(automatedAdjustment)) {
                    flag = true;
                    tips += "自动化方案调整内容或自动化工作内容调整有误\t";
                }
            }
            if ("是".equals(otherAdjusted)) {
                if (empty(descriptionReasons) || empty(descriptionReasons)) {
                    flag = true;
                    tips += "其他方案调整原因描述有误\t";
                }
            }
            if (flag == true) {
                fin += "<" + c.getReserveProjectName() + ">" + ":" + tips + "</br>";
            } else {
                newConList.add(c);
            }
        }
        Map<String, Object> returnMap = new HashMap<>();
        returnMap.put("fin", fin);
        returnMap.put("newConList", newConList);
        return returnMap;
    }

    private static boolean empty(String sceneDescription) {
        return "".equals(sceneDescription) || sceneDescription == null;
    }

    //则现场设备尺寸、最多可扩容尺寸需填写，且默认单位为米
    public static Construction getAddUnit(Construction construction) {
        String size = "";
        /*if (null!=construction.getDisclose()){
            size = construction.getDisclose().getSceneSize();
            if (null!=size&&!"".equals(size)){
                if (!size.contains("米")){
                    construction.getDisclose().setSceneSize(size+"米");
                }
            }
            size = construction.getDisclose().getCapacitySize();
            if (null!=size && !"".equals(size)){
                if (!size.contains("米")){
                    construction.getDisclose().setCapacitySize(size+"米");
                }
            }
        }*/
        return construction;
    }

    //人工审核：回显
    public static void getTheEcho(Construction construction, Model model) {
        Disclose disclose = construction.getDisclose();
        String hasImplemented = disclose.getHasImplemented();
        String isImplement = disclose.getIsImplement();
        String whetherComplete = disclose.getWhetherComplete();
        String whetherStandard = disclose.getWhetherStandard();
        String whetherDrawing = disclose.getWhetherDrawing();
        String whetherChannel = disclose.getWhetherChannel();
        String civilAdjusted = disclose.getCivilAdjusted();
        String electricalAdjusted = disclose.getElectricalAdjusted();
        String doesChange = disclose.getDoesChange();
        String otherAdjusted = disclose.getOtherAdjusted();

        String difficultResolve = disclose.getDifficultResolve();
        String designChanges = disclose.getDesignChanges();
        String needsClosed = disclose.getNeedsClosed();

        String preconditions = disclose.getPreconditions();
        String customizedMaterials = disclose.getCustomizedMaterials();
        String demolitionMaterials = disclose.getDemolitionMaterials();


        if ("否".equals(hasImplemented)
                && "是".equals(isImplement)
                && "是".equals(whetherComplete)
                && "是".equals(whetherStandard)
                && "否".equals(whetherDrawing)
                && "否".equals(whetherChannel)
                && "否".equals(civilAdjusted)
                && "否".equals(electricalAdjusted)
                && "否".equals(doesChange)
                && "否".equals(otherAdjusted)
                && "否".equals(designChanges)
                && "否".equals(needsClosed)
                && "否".equals(preconditions)
                && "否".equals(customizedMaterials)
                && "否".equals(demolitionMaterials)) {
            model.addAttribute("noProblem", true);
        } else {
            if ("是".equals(hasImplemented)
                    || "否".equals(isImplement)
                    || "是".equals(demolitionMaterials)) {
                model.addAttribute("closed", true);
            } else if ("否".equals(whetherComplete)
                    || "否".equals(whetherStandard)
                    || "是".equals(whetherDrawing)
                    || "是".equals(whetherChannel)
                    || "是".equals(civilAdjusted)
                    || "是".equals(electricalAdjusted)
                    || "是".equals(doesChange)
                    || "是".equals(otherAdjusted)
                    || "是".equals(preconditions)
                    || "是".equals(customizedMaterials)) {
                model.addAttribute("design", true);
            }
        }
        if ("是".equals(difficultResolve)) {
            if ("是".equals(needsClosed)) {
                model.addAttribute("closed", true);
            } else if ("是".equals(designChanges)) {
                model.addAttribute("design", true);
            }
        }
    }

    //政策处理类型判断
    public static void getAdministrationTypeView(String administrationType, Model model) {
        if (administrationType.length() > 0) {
            String[] split = administrationType.split(";");
            for (String str : split) {
                if (str.contains("农村政处")) {
                    model.addAttribute("pass_construction3", "0");
                }
                //2.民事政处/行政政处（公路/水利）
                if (str.contains("民事政处/行政政处（公路/水利）")) {
                    model.addAttribute("pass_construction4", "0");
                }
                if (str.contains("行政政处（城区道路）")) {
                    model.addAttribute("pass_construction5", "0");
                }
            }
        }
    }

    //     if (str.equals("2.农村政处")){
//        model.addAttribute("pass_construction3","0");
//    }
//    //2.民事政处/行政政处（公路/水利）
//                if (str.equals("3.民事政处/行政政处（公路/水利）")){
//        model.addAttribute("pass_construction4","0");
//    }
//    //3.行政政处（城区道路）
//                if (str.equals("4.行政政处（城区道路）")){
//        model.addAttribute("pass_construction5","0");
//    }
    //政策处理类型判断
    public static String getAdministrationJudge(Disclose disclose, String tips) {
        /*if ("".equals(disclose.getAdministrationType()) || disclose.getAdministrationType() == null) {
            tips += "政处类型填写有误;";
            return tips;
        }
        boolean flag = true;
        String[] split = disclose.getAdministrationType().split(";");
        for (String str : split){
            if (!str.contains("农村政处")&&!str.contains("民事政处/行政政处（公路/水利）")&&!str.contains("行政政处（城区道路）")&&!str.contains("无")){
                tips+="政处类型填写有误";
                flag = false;
                break;
            }
        }
        if (flag){
            if (!disclose.getAdministrationType().contains("1.无")){
                if ("".equals(disclose.getPolicyHandlingInstructions()) || disclose.getPolicyHandlingInstructions() == null) {
                    tips += "政策处理说明填有误;";
                }
            }
        }
        return tips;
    }
    //人工审核：判断
    public static String getHumanReviewJudge(Disclose disclose){
        String tips = "";
        if ("".equals(disclose.getRequireName()) || disclose.getRequireName() == null) {
            tips +="项目名称有误;";
        }
        if ("".equals(disclose.getCapacity()) || disclose.getCapacity() == null||(!"有".equals(disclose.getCapacity())&&!"无".equals(disclose.getCapacity()))) {
            tips += "设备基础是否可以扩容填写有误;";
        }else {
            if ("是".equals(disclose.getCapacity())){
                if ("".equals(disclose.getSceneSize())||disclose.getSceneSize() == null){
                    tips+="现场设备尺寸有误;";
                }
                if ("".equals(disclose.getCapacitySize())||disclose.getCapacitySize()==null){
                    tips+="最多可扩容尺寸有误;";
                }
            }
        }
        if ("".equals(disclose.getHiddenDanger()) || disclose.getHiddenDanger() == null||(!"有".equals(disclose.getHiddenDanger())&&!"无".equals(disclose.getHiddenDanger()))) {
            tips += "方案安全隐患填写有误;";
        }
        if ("".equals(disclose.getInfluenceConstruction()) || disclose.getInfluenceConstruction() == null||(!"是".equals(disclose.getInfluenceConstruction())&&!"否".equals(disclose.getInfluenceConstruction()))) {
            tips += "是否存在低压或通信线等影响施工填写有误;";
        }
        if ("".equals(disclose.getProjectRepetition()) || disclose.getProjectRepetition() == null||(!"是".equals(disclose.getProjectRepetition())&&!"否".equals(disclose.getProjectRepetition()))) {
            tips += "立项重复填写有误;";
        }
        if ("".equals(disclose.getImplemented()) || disclose.getImplemented() == null||(!"是".equals(disclose.getImplemented())&&!"否".equals(disclose.getImplemented()))) {
            tips += "是否已实施填写有误;";
        }
        if ("".equals(disclose.getTransformer()) || disclose.getTransformer() == null||(!"有".equals(disclose.getTransformer())&&!"无".equals(disclose.getTransformer()))) {
            tips += "变压器无负荷填写有误;";
        }
        if ("有".equals(disclose.getHiddenDanger()) || "是".equals(disclose.getInfluenceConstruction())|| "是".equals(disclose.getProjectRepetition())|| "是".equals(disclose.getImplemented())|| "无".equals(disclose.getTransformer())) {
            if ("".equals(disclose.getExplanationOfNecessity()) || disclose.getExplanationOfNecessity() == null) {
                tips += "必要性问题说明有误;";
            }
        }
        if ("".equals(disclose.getLineName()) || disclose.getLineName() == null||(!"一致".equals(disclose.getLineName())&&!"不一致".equals(disclose.getLineName()))) {
            tips += "线路名称、设备、开关、杆号一致性填写有误;";
        }
        if ("".equals(disclose.getQuantities()) || disclose.getQuantities() == null||(!"是".equals(disclose.getQuantities())&&!"否".equals(disclose.getQuantities()))) {
            tips += "工程量是否一致填写有误;";
        }
        if ("否".equals(disclose.getLineName())||"否".equals(disclose.getQuantities())) {
            if ("".equals(disclose.getInconsistentDescription()) || disclose.getInconsistentDescription() == null) {
                tips += "图纸现场不一致说明有误;";
            }
        }
//        if ("".equals(disclose.getAdministrationType()) || disclose.getAdministrationType() == null||(!"1.农村政处".equals(disclose.getAdministrationType())&&!"2.民事政处/行政政处（公路/水利）".equals(disclose.getAdministrationType())&&!"3.行政政处（城区道路）".equals(disclose.getAdministrationType())&&!"4.无".equals(disclose.getAdministrationType()))) {
////            tips += "政处类型填写有误;";
////        }else {
////            if (("1.农村政处".equals(disclose.getAdministrationType())||"2.民事政处/行政政处（公路/水利）".equals(disclose.getAdministrationType())||"3.行政政处（城区道路）".equals(disclose.getAdministrationType()))) {
////                if ("".equals(disclose.getPolicyHandlingInstructions()) || disclose.getPolicyHandlingInstructions() == null) {
////                    tips += "政策处理说明填写有误;";
////                }
////            }
////        }
        tips = getAdministrationJudge(disclose, tips);
        //DTU  安放方式检查
        if ("".equals(disclose.getPlacementMode())||disclose.getPlacementMode() == null||(!"户外".equals(disclose.getPlacementMode())&&!"户内".equals(disclose.getPlacementMode())&&!"无".equals(disclose.getPlacementMode()))){
            tips+="DTU安放方式核查填写有误";
        }else {
            if ("户外".equals(disclose.getPlacementMode())||"户内".equals(disclose.getPlacementMode())){
                if ("".equals(disclose.getProductionDate())||disclose.getProductionDate() == null){
                    tips +="核查环网柜生产日期有误;";
                }
            }
        }
        if ("".equals(disclose.getIntegrateModule()) || disclose.getIntegrateModule() == null) {
            tips += "二次是否是集成模块有误;";
        }else {
            if (!"是".equals(disclose.getIntegrateModule())&&!"否".equals(disclose.getIntegrateModule())){
                tips += "二次是否是集成模块填写有误;";
            }
        }
        if ("".equals(disclose.getNeedReplace()) || disclose.getNeedReplace() == null) {
            tips += "PT是否需要更换有误;";
        }else {
            if (!"是".equals(disclose.getNeedReplace())&&!"否".equals(disclose.getNeedReplace())){
                tips += "PT是否需要更换填写有误;";
            }
        }
        if ("".equals(disclose.getOverallTransformation()) || disclose.getOverallTransformation() == null) {
            tips += "设备是否有整体改造的必要有误;";
        }else {
            if (!"是".equals(disclose.getOverallTransformation())&&!"否".equals(disclose.getOverallTransformation())){
                tips += "设备是否有整体改造的必要填写有误;";
            }
        }*/
        return tips;
    }
}
